package mcmultipart.item;

import mcmultipart.multipart.IMultipart;
import mcmultipart.multipart.MultipartHelper;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.Vec3;
import net.minecraft.world.World;

public abstract class ItemMultiPart extends Item {

    public abstract IMultipart createPart(World world, BlockPos pos, EnumFacing side, Vec3 hit, ItemStack stack, EntityPlayer player);

    public boolean place(World world, BlockPos pos, EnumFacing side, Vec3 hit, ItemStack stack, EntityPlayer player) {

        IMultipart mb = createPart(world, pos, side, hit, stack, player);

        if (MultipartHelper.canAddPart(world, pos, mb)) {
            if (!world.field_72995_K) MultipartHelper.addPart(world, pos, mb);
            consumeItem(stack);

            Block.SoundType sound = getPlacementSound(stack);
            if (sound != null)
                world.func_72908_a(pos.func_177958_n() + 0.5, pos.func_177956_o() + 0.5, pos.func_177952_p() + 0.5, sound.func_150496_b(), sound.func_150497_c(),
                        sound.func_150494_d());

            return true;
        }

        return false;
    }

    protected void consumeItem(ItemStack stack) {

        stack.field_77994_a--;
    }

    @Override
    public boolean func_180614_a(ItemStack stack, EntityPlayer player, World world, BlockPos pos, EnumFacing side, float hitX, float hitY,
            float hitZ) {

        Vec3 hit = new Vec3(hitX, hitY, hitZ);
        double depth = ((hit.field_72450_a * 2 - 1) * side.func_82601_c() + (hit.field_72448_b * 2 - 1) * side.func_96559_d() + (hit.field_72449_c * 2 - 1)
                * side.func_82599_e());
        if (depth < 1 && place(world, pos, side, hit, stack, player)) return true;
        return place(world, pos.func_177972_a(side), side.func_176734_d(), hit, stack, player);
    }

    public Block.SoundType getPlacementSound(ItemStack stack) {

        return Block.field_149778_k;
    }

    @Override
    public boolean func_82788_x() {

        return true;
    }

}
