package mcmultipart.microblock;

import java.util.Map.Entry;

import net.minecraft.block.Block;
import net.minecraft.block.Block.SoundType;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumWorldBlockLayer;
import net.minecraft.world.IBlockAccess;

import com.google.common.base.Function;
import com.google.common.base.Joiner;
import com.google.common.collect.Iterables;

import net.minecraft.block.Block.SoundType;
public class BlockMicroMaterial implements IMicroMaterial {

    private static final Joiner COMMA_JOINER = Joiner.on(',');
    @SuppressWarnings("rawtypes")
    private static final Function<Entry<IProperty, Comparable>, String> MAP_ENTRY_TO_STRING = new Function<Entry<IProperty, Comparable>, String>() {

        @SuppressWarnings("unchecked")
        @Override
        public String apply(Entry<IProperty, Comparable> entry) {

            if (entry == null) {
                return "<NULL>";
            } else {
                IProperty iproperty = entry.getKey();
                return iproperty.func_177701_a() + "=" + iproperty.func_177702_a(entry.getValue());
            }
        }
    };

    private IBlockState blockState;
    private String name;

    public BlockMicroMaterial(IBlockState blockState) {

        this.blockState = blockState;
        genName();
    }

    private void genName() {

        StringBuilder stringbuilder = new StringBuilder();
        stringbuilder.append(Block.field_149771_c.func_177774_c(blockState.func_177230_c()));
        if (!blockState.func_177228_b().isEmpty()) {
            stringbuilder.append("[");
            COMMA_JOINER.appendTo(stringbuilder, Iterables.transform(blockState.func_177228_b().entrySet(), MAP_ENTRY_TO_STRING));
            stringbuilder.append("]");
        }
        name = stringbuilder.toString();
    }

    @Override
    public String getName() {

        return name;
    }

    @Override
    public String getLocalizedName() {

        return getItem().func_82833_r();
    }

    @Override
    public boolean isSolid() {

        return blockState.func_177230_c().func_149686_d();
    }

    @Override
    public int getLightValue() {

        return blockState.func_177230_c().func_149750_m();
    }

    @Override
    public float getHardness() {

        return 1;
    }

    @Override
    public int getSawStrength() {

        return blockState.func_177230_c().getHarvestLevel(blockState);
    }

    @Override
    public ItemStack getItem() {

        return new ItemStack(blockState.func_177230_c(), 1, blockState.func_177230_c().func_176201_c(blockState));
    }

    @Override
    public SoundType getSound() {

        return blockState.func_177230_c().field_149762_H;
    }

    @Override
    public boolean canRenderInLayer(EnumWorldBlockLayer layer) {

        return blockState.func_177230_c().canRenderInLayer(layer);
    }

    @Override
    public IBlockState getMaterialState(IBlockAccess world, BlockPos pos, IMicroblock microblock) {

        return blockState;
    }

}
